"use strict";

var _setup = require("./setup");

var _compress = require("./compress");

/*!
 * node-minify
 * Copyright(c) 2011-2019 Rodolphe Stoclin
 * MIT Licensed
 */

/**
 * Module dependencies.
 */

/**
 * Run node-minify.
 *
 * @param {Object} settings - Settings from user input
 */
const minify = settings => {
  return new Promise((resolve, reject) => {
    settings = (0, _setup.setup)(settings);

    if (!settings.sync) {
      (0, _compress.compress)(settings).then(minified => {
        if (settings.callback) {
          settings.callback(null, minified);
        }

        resolve(minified);
      }).catch(err => {
        if (settings.callback) {
          settings.callback(err);
        }

        reject(err);
      });
    } else {
      const minified = (0, _compress.compress)(settings);

      if (settings.callback) {
        settings.callback(null, minified);
      }

      resolve(minified);
    }
  });
};
/**
 * Expose `minify()`.
 */


module.exports = minify;